## nextpnr 0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(nextpnr CXX C)

# Allow family.cmake add additional dependencies to gui_${family}.
cmake_policy(SET CMP0079 NEW)

# Enable IPO support.
cmake_policy(SET CMP0069 NEW)
include(CheckIPOSupported)
check_ipo_supported(RESULT ipo_supported)

option(BUILD_GUI "Build GUI" OFF)
option(BUILD_PYTHON "Build Python Integration" ON)
option(BUILD_TESTS "Build tests" OFF)
option(BUILD_HEAP "Build HeAP analytic placer" ON)
option(USE_OPENMP "Use OpenMP to accelerate analytic placer" OFF)
option(COVERAGE "Add code coverage info" OFF)
option(STATIC_BUILD "Create static build" OFF)
option(EXTERNAL_CHIPDB "Create build with pre-built chipdb binaries" OFF)
option(WERROR "pass -Werror to compiler (used for CI)" OFF)
option(PROFILER "Link against libprofiler" OFF)
option(USE_IPO "Compile nextpnr with IPO" ON)

if (USE_IPO)
    if (ipo_supported)
        message(STATUS "Building with IPO")
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
    else()
        message(STATUS "IPO is not supported with this compiler")
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
    endif()
else()
    message(STATUS "Building without IPO")
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
endif()

if(WIN32 OR EXTERNAL_CHIPDB)
    set(BBASM_MODE "binary")
else()
    set(BBASM_MODE "string")
endif()

set(Boost_NO_BOOST_CMAKE ON)

if(WASI)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lwasi-emulated-mman")
    set(USE_THREADS OFF)
    add_definitions(
        -DBOOST_EXCEPTION_DISABLE
        -DBOOST_NO_EXCEPTIONS
        -DBOOST_SP_NO_ATOMIC_ACCESS
        -DBOOST_AC_DISABLE_THREADS
        -DBOOST_NO_CXX11_HDR_MUTEX
    )
else()
    set(USE_THREADS ON)
    find_package(TBB QUIET)
    if (TBB_FOUND)
        add_definitions(-DNEXTPNR_USE_TBB)
    endif()
endif()

if (NOT USE_THREADS)
    add_definitions(-DNPNR_DISABLE_THREADS)
endif()

set(link_param "")
if (STATIC_BUILD)
    set(Boost_USE_STATIC_LIBS   ON)
    if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
        if (MSVC)
            set(CMAKE_CXX_FLAGS_RELEASE "/MT")
            set(CMAKE_CXX_FLAGS_DEBUG "/MTd")
        endif()
    else()
        set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ".so")
        set(link_param "-static")
        if (BUILD_PYTHON)
            find_package(ZLIB)
            find_package(EXPAT)
            find_package(Threads)
        endif()
    endif()
endif()

if (EXTERNAL_CHIPDB)
    set(EXTERNAL_CHIPDB_ROOT "${CMAKE_INSTALL_PREFIX}/share/nextpnr" CACHE STRING
        "External chipdb path")
    message(STATUS "Using external chipdb path: ${EXTERNAL_CHIPDB_ROOT}")
    add_definitions("-DEXTERNAL_CHIPDB_ROOT=\"${EXTERNAL_CHIPDB_ROOT}\"")
endif()

set(PROGRAM_PREFIX "" CACHE STRING "Name prefix for executables")

# List of families to build
set(FAMILIES generic ice40 ecp5 nexus gowin fpga_interchange machxo2 mistral)
set(STABLE_FAMILIES generic ice40 ecp5)
set(EXPERIMENTAL_FAMILIES nexus gowin fpga_interchange machxo2 mistral)

set(ARCH "" CACHE STRING "Architecture family for nextpnr build")
set_property(CACHE ARCH PROPERTY STRINGS ${FAMILIES})

if (NOT ARCH)
    message(STATUS "Architecture needs to be set, set desired one with -DARCH=xxx")
    message(STATUS "Supported architectures are :")
    message(STATUS "  all")
    message(STATUS "  all+alpha")
    foreach(item ${FAMILIES})
        message(STATUS "  ${item}")
    endforeach()
    message(FATAL_ERROR "Architecture setting is mandatory")
endif ()

if (ARCH STREQUAL "all+alpha")
    SET(ARCH ${STABLE_FAMILIES} ${EXPERIMENTAL_FAMILIES})
endif()


if (ARCH STREQUAL "all")
    SET(ARCH ${STABLE_FAMILIES})
endif()

foreach(item ${ARCH})
    if (NOT item IN_LIST FAMILIES)
        message(FATAL_ERROR "Architecture '${item}' not in list of supported architectures")
    endif()
endforeach()

set(CMAKE_CXX_STANDARD 14)
if (MSVC)
    set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /D_DEBUG /W4 /wd4100 /wd4244 /wd4125 /wd4800 /wd4456 /wd4458 /wd4305 /wd4459 /wd4121 /wd4996")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /W4 /wd4100 /wd4244 /wd4125 /wd4800 /wd4456 /wd4458 /wd4305 /wd4459 /wd4121 /wd4996 /wd4127")
else()
    # N.B. the -Wno-array-bounds is to work around a false positive in GCC 9
    set(WARN_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers -Wno-array-bounds")
    if (WERROR)
        set(WARN_FLAGS "${WARN_FLAGS} -Werror")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG "${WARN_FLAGS} -fPIC -ggdb -pipe")
    if (USE_OPENMP)
        set(CMAKE_CXX_FLAGS_RELEASE "${WARN_FLAGS} -fPIC -O3 -g -pipe -fopenmp")
    else()
        set(CMAKE_CXX_FLAGS_RELEASE "${WARN_FLAGS} -fPIC -O3 -g -pipe")
    endif()
endif()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/3rdparty/sanitizers-cmake/cmake;." ${CMAKE_MODULE_PATH})

if (COVERAGE)
    include(CodeCoverage)
endif()

if(NOT DEFINED CMAKE_SUPPRESS_DEVELOPER_WARNINGS)
     set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 1 CACHE INTERNAL "No dev warnings")
endif()

find_package(Sanitizers)

# List of Boost libraries to include
set(boost_libs filesystem program_options iostreams system)
if (USE_THREADS)
    list(APPEND boost_libs thread)
endif()

if (BUILD_GUI AND NOT BUILD_PYTHON)
    message(FATAL_ERROR "GUI requires Python to build")
endif()

if (BUILD_GUI)
    # For higher quality backtraces
    set(CMAKE_ENABLE_EXPORTS ON)
endif()

find_package(PythonInterp 3.5 REQUIRED)
if (BUILD_PYTHON)
    # TODO: sensible minimum Python version
    find_package(PythonLibs 3.5 REQUIRED)
else()
    add_definitions("-DNO_PYTHON")
endif()

find_package(Boost REQUIRED COMPONENTS ${boost_libs})

if (BUILD_GUI)
    # Find the Qt5 libraries
    find_package(Qt5 COMPONENTS Core Widgets OpenGL REQUIRED)
    find_package(OpenGL REQUIRED)
else()
    add_definitions("-DNO_GUI")
endif()

if (NOT DEFINED CURRENT_GIT_VERSION)
    # Get the latest abbreviated commit hash of the working branch
    # if not already defined outside (e.g. by package manager when building
    # outside of git repository)
    execute_process(
      COMMAND git describe --tags --always
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE CURRENT_GIT_VERSION
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif()

if (BUILD_TESTS)
    add_subdirectory(3rdparty/googletest/googletest ${CMAKE_CURRENT_BINARY_DIR}/generated/3rdparty/googletest EXCLUDE_FROM_ALL)
    enable_testing()
endif()

if (BUILD_GUI)
    add_subdirectory(3rdparty/QtPropertyBrowser ${CMAKE_CURRENT_BINARY_DIR}/generated/3rdparty/QtPropertyBrowser EXCLUDE_FROM_ALL)
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/common/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/generated/version.h
)

include_directories(common/ json/ frontend/ 3rdparty/json11/ 3rdparty/pybind11/include ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})

if(BUILD_HEAP)
    find_package (Eigen3 REQUIRED NO_MODULE)
    include_directories(${EIGEN3_INCLUDE_DIRS})
    add_definitions(${EIGEN3_DEFINITIONS})
    add_definitions(-DWITH_HEAP)
endif()

aux_source_directory(common/ COMMON_SRC_FILES)
aux_source_directory(json/ JSON_PARSER_FILES)
aux_source_directory(3rdparty/json11 EXT_JSON11_FILES)
aux_source_directory(frontend/ FRONTEND_FILES)

set(COMMON_FILES ${COMMON_SRC_FILES} ${EXT_JSON11_FILES} ${JSON_PARSER_FILES} ${FRONTEND_FILES})
if( NOT CMAKE_BUILD_TYPE )
    set(CMAKE_BUILD_TYPE Release)
endif()

if(CMAKE_CROSSCOMPILING)
    set(BBA_IMPORT "IMPORTFILE-NOTFOUND" CACHE FILEPATH
        "Path to the `bba-export.cmake` export file from a native build")
    include(${BBA_IMPORT})
else()
    add_subdirectory(bba)
endif()

include(TestBigEndian)
test_big_endian(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
    set(BBASM_ENDIAN_FLAG "--be")
else()
    set(BBASM_ENDIAN_FLAG "--le")
endif()

set(EXTRA_LIB_DEPS)

if(PROFILER)
    list(APPEND EXTRA_LIB_DEPS profiler)
endif()
if(TBB_FOUND)
    list(APPEND EXTRA_LIB_DEPS tbb)
endif()

foreach (family ${ARCH})
    message(STATUS "Configuring architecture: ${family}")
    string(TOUPPER ${family} ufamily)
    aux_source_directory(${family}/ ${ufamily}_FILES)

    if (BUILD_GUI)
       add_subdirectory(gui ${CMAKE_CURRENT_BINARY_DIR}/generated/gui/${family} EXCLUDE_FROM_ALL)
    endif()

    # Add the CLI binary target
    add_executable(${PROGRAM_PREFIX}nextpnr-${family} ${COMMON_FILES} ${${ufamily}_FILES})
    if (WASI)
        # set(CMAKE_EXECUTABLE_SUFFIX) breaks CMake tests for some reason
        set_property(TARGET ${PROGRAM_PREFIX}nextpnr-${family} PROPERTY SUFFIX ".wasm")
    endif()
    install(TARGETS ${PROGRAM_PREFIX}nextpnr-${family} RUNTIME DESTINATION bin)
    target_compile_definitions(${PROGRAM_PREFIX}nextpnr-${family} PRIVATE MAIN_EXECUTABLE)

    # Add any new per-architecture targets here
    if (BUILD_TESTS)
        if (COVERAGE)
            APPEND_COVERAGE_COMPILER_FLAGS()
            set(COVERAGE_LCOV_EXCLUDES '/usr/include/*' '3rdparty/*' 'generated/*' 'bba/*' 'tests/*')
            SETUP_TARGET_FOR_COVERAGE_LCOV(
                NAME ${family}-coverage
                EXECUTABLE ${PROGRAM_PREFIX}nextpnr-${family}-test
                DEPENDENCIES ${PROGRAM_PREFIX}nextpnr-${family}-test
            )
        endif()

        aux_source_directory(tests/${family}/ ${ufamily}_TEST_FILES)
        if (BUILD_GUI)
            aux_source_directory(tests/gui/ GUI_TEST_FILES)
        endif()

        add_executable(${PROGRAM_PREFIX}nextpnr-${family}-test ${${ufamily}_TEST_FILES}
                ${COMMON_FILES} ${${ufamily}_FILES} ${GUI_TEST_FILES})
        target_link_libraries(${PROGRAM_PREFIX}nextpnr-${family}-test PRIVATE gtest_main)
        add_sanitizers(${PROGRAM_PREFIX}nextpnr-${family}-test)

        add_test(${family}-test ${CMAKE_CURRENT_BINARY_DIR}/nextpnr-${family}-test)
    endif()

    # Set ${family_targets} to the list of targets being build for this family
    set(family_targets ${PROGRAM_PREFIX}nextpnr-${family})

    if (BUILD_TESTS)
        set(family_targets ${family_targets} ${PROGRAM_PREFIX}nextpnr-${family}-test)
    endif()

    # Include the family-specific CMakeFile
    include(${family}/family.cmake)
    foreach (target ${family_targets})
        foreach(lib_dep ${EXTRA_LIB_DEPS})
            target_link_libraries(${target} PRIVATE ${lib_dep})
        endforeach()

        # Include family-specific source files to all family targets and set defines appropriately
        target_include_directories(${target} PRIVATE ${family}/ ${CMAKE_CURRENT_BINARY_DIR}/generated/)
        target_compile_definitions(${target} PRIVATE NEXTPNR_NAMESPACE=nextpnr_${family} ARCH_${ufamily} ARCHNAME=${family})
        target_link_libraries(${target} LINK_PUBLIC ${Boost_LIBRARIES} ${link_param})
        if (NOT MSVC)
            target_link_libraries(${target} LINK_PUBLIC pthread)
        endif()
        add_sanitizers(${target})
        if (BUILD_GUI)
            target_include_directories(${target} PRIVATE gui/${family}/ gui/)
            target_compile_definitions(${target} PRIVATE QT_NO_KEYWORDS)
            target_link_libraries(${target} LINK_PUBLIC gui_${family} ${GUI_LIBRARY_FILES_${ufamily}})
        endif()
        if (BUILD_PYTHON)
            target_link_libraries(${target} LINK_PUBLIC ${PYTHON_LIBRARIES})
            if (STATIC_BUILD)
                target_link_libraries(${target} LINK_PUBLIC ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_DL_LIBS} ${ZLIB_LIBRARIES} ${EXPAT_LIBRARIES})
                if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
                elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
                else()
                    target_link_libraries(${target} LINK_PUBLIC -lutil)
                endif()
            endif()
        endif()
    endforeach (target)
endforeach (family)

file(GLOB_RECURSE CLANGFORMAT_FILES *.cc *.h)
string(REGEX REPLACE "[^;]*/ice40/chipdb/chipdb-[^;]*.cc" "" CLANGFORMAT_FILES "${CLANGFORMAT_FILES}")

=== ecp5/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(chipdb-ecp5 NONE)

set(ALL_ECP5_DEVICES 25k 45k 85k)
set(ECP5_DEVICES ${ALL_ECP5_DEVICES} CACHE STRING
    "Include support for these ECP5 devices (available: ${ALL_ECP5_DEVICES})")
message(STATUS "Enabled ECP5 devices: ${ECP5_DEVICES}")

if(DEFINED ECP5_CHIPDB)
    add_custom_target(chipdb-ecp5-bbas ALL)
else()
    find_package(PythonInterp 3.5 REQUIRED)

    # shared among all families
    set(SERIALIZE_CHIPDBS TRUE CACHE BOOL
        "Serialize device data preprocessing to minimize memory use")

    set(TRELLIS_PROGRAM_PREFIX "" CACHE STRING
        "Trellis name prefix")
    if(TRELLIS_PROGRAM_PREFIX)
        message(STATUS "Trellis program prefix: ${TRELLIS_PROGRAM_PREFIX}")
    endif()

    set(TRELLIS_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE STRING
        "Trellis install prefix")
    message(STATUS "Trellis install prefix: ${TRELLIS_INSTALL_PREFIX}")

    if(NOT TRELLIS_LIBDIR)
        # The pytrellis library isn't a normal shared library, but rather a native Python library;
        # it does not follow the normal platform conventions for shared libraries, so we can't just
        # use find_library() here. Instead, we emulate the useful parts of the find_library() logic
        # for use with find_path().
        set(pytrellis_paths)
        foreach(prefix_path ${CMAKE_PREFIX_PATH})
            list(APPEND pytrellis_paths ${prefix_path}/lib)
            if(CMAKE_LIBRARY_ARCHITECTURE)
                list(APPEND pytrellis_paths ${prefix_path}/lib/${CMAKE_LIBRARY_ARCHITECTURE})
            endif()
        endforeach()
        list(APPEND pytrellis_paths ${CMAKE_LIBRARY_PATH})
        if(NOT NO_CMAKE_SYSTEM_PATH)
            foreach(prefix_path ${CMAKE_SYSTEM_PREFIX_PATH})
                list(APPEND pytrellis_paths ${prefix_path}/lib)
                if(CMAKE_LIBRARY_ARCHITECTURE)
                    list(APPEND pytrellis_paths ${prefix_path}/lib/${CMAKE_LIBRARY_ARCHITECTURE})
                endif()
            endforeach()
            list(APPEND pytrellis_paths ${CMAKE_SYSTEM_LIBRARY_PATH})
        endif()
        message(STATUS "Searching for pytrellis in: ${pytrellis_paths}")

        if(WIN32)
            set(pytrellis_lib pytrellis.pyd)
        else()
            set(pytrellis_lib pytrellis${CMAKE_SHARED_MODULE_SUFFIX})
        endif()

        find_path(TRELLIS_LIBDIR ${pytrellis_lib}
            HINTS ${TRELLIS_INSTALL_PREFIX}/lib/${TRELLIS_PROGRAM_PREFIX}trellis
            PATHS ${pytrellis_paths}
            PATH_SUFFIXES ${TRELLIS_PROGRAM_PREFIX}trellis
            DOC "Location of the pytrellis library")
        if(NOT TRELLIS_LIBDIR)
            message(FATAL_ERROR "Failed to locate the pytrellis library")
        endif()
    endif()
    message(STATUS "Trellis library directory: ${TRELLIS_LIBDIR}")

    if(NOT TRELLIS_DATADIR)
        set(TRELLIS_DATADIR ${TRELLIS_INSTALL_PREFIX}/share/${TRELLIS_PROGRAM_PREFIX}trellis)
    endif()
    message(STATUS "Trellis data directory: ${TRELLIS_DATADIR}")

    set(all_device_bbas)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/chipdb)
    foreach(device ${ECP5_DEVICES})
        if(NOT device IN_LIST ALL_ECP5_DEVICES)
            message(FATAL_ERROR "Device ${device} is not a supported ECP5 device")
        endif()

        set(device_bba chipdb/chipdb-${device}.bba)
        add_custom_command(
            OUTPUT ${device_bba}
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/trellis_import.py
                -L ${TRELLIS_LIBDIR}
                -L ${TRELLIS_DATADIR}/util/common
                -L ${TRELLIS_DATADIR}/timing/util
                -p ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
                -g ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
                ${device}
                > ${device_bba}.new
            # atomically update
            COMMAND ${CMAKE_COMMAND} -E rename ${device_bba}.new ${device_bba}
            DEPENDS
                ${CMAKE_CURRENT_SOURCE_DIR}/trellis_import.py
                ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
                ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
                ${PREVIOUS_CHIPDB_TARGET}
            VERBATIM)
        list(APPEND all_device_bbas ${device_bba})
        if(SERIALIZE_CHIPDBS)
            set(PREVIOUS_CHIPDB_TARGET ${CMAKE_CURRENT_BINARY_DIR}/${device_bba})
        endif()
    endforeach()

    add_custom_target(chipdb-ecp5-bbas ALL DEPENDS ${all_device_bbas})

    get_directory_property(has_parent PARENT_DIRECTORY)
    if(has_parent)
        set(ECP5_CHIPDB ${CMAKE_CURRENT_BINARY_DIR}/chipdb PARENT_SCOPE)
        # serialize chipdb build across multiple architectures
        set(PREVIOUS_CHIPDB_TARGET chipdb-ecp5-bbas PARENT_SCOPE)
    else()
        message(STATUS "Build nextpnr with -DECP5_CHIPDB=${CMAKE_CURRENT_BINARY_DIR}/chipdb")
    endif()
endif()

=== gowin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(chipdb-gowin NONE)

set(ALL_GOWIN_DEVICES GW1N-1 GW1N-4 GW1N-9 GW1NS-2)
set(GOWIN_DEVICES ${ALL_GOWIN_DEVICES} CACHE STRING
    "Include support for these Gowin devices (available: ${ALL_GOWIN_DEVICES})")
message(STATUS "Enabled Gowin devices: ${GOWIN_DEVICES}")

find_program (GOWIN_BBA_EXECUTABLE gowin_bba)
message(STATUS "gowin_bba executable: ${GOWIN_BBA_EXECUTABLE}")

if(DEFINED GOWIN_CHIPDB)
    add_custom_target(chipdb-gowin-bbas ALL)
else()
    # shared among all families
    set(SERIALIZE_CHIPDBS TRUE CACHE BOOL
        "Serialize device data preprocessing to minimize memory use")

    set(all_device_bbas)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/chipdb)
    foreach(device ${GOWIN_DEVICES})
        if(NOT device IN_LIST ALL_GOWIN_DEVICES)
            message(FATAL_ERROR "Device ${device} is not a supported Gowin device")
        endif()

        set(device_bba chipdb/chipdb-${device}.bba)
        add_custom_command(
            OUTPUT ${device_bba}
            COMMAND ${GOWIN_BBA_EXECUTABLE} -d ${device} -i ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc -o ${device_bba}.new
            # atomically update
            COMMAND ${CMAKE_COMMAND} -E rename ${device_bba}.new ${device_bba}
            DEPENDS
                ${GOWIN_BBA_EXECUTABLE}
                ${PREVIOUS_CHIPDB_TARGET}
                ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            VERBATIM)
        list(APPEND all_device_bbas ${device_bba})
        if(SERIALIZE_CHIPDBS)
            set(PREVIOUS_CHIPDB_TARGET ${CMAKE_CURRENT_BINARY_DIR}/${device_bba})
        endif()
    endforeach()

    add_custom_target(chipdb-gowin-bbas ALL DEPENDS ${all_device_bbas})

    get_directory_property(has_parent PARENT_DIRECTORY)
    if(has_parent)
        set(GOWIN_CHIPDB ${CMAKE_CURRENT_BINARY_DIR}/chipdb PARENT_SCOPE)
        # serialize chipdb build across multiple architectures
        set(PREVIOUS_CHIPDB_TARGET chipdb-gowin-bbas PARENT_SCOPE)
    else()
        message(STATUS "Build nextpnr with -DGOWIN_CHIPDB=${CMAKE_CURRENT_BINARY_DIR}/chipdb")
    endif()
endif()

=== machxo2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(chipdb-machxo2 NONE)

# set(ALL_MACHXO2_DEVICES 256 640 1200 2000 4000 7000)
set(ALL_MACHXO2_DEVICES 1200)
set(MACHXO2_DEVICES 1200 CACHE STRING
    "Include support for these MachXO2 devices (available: ${ALL_MACHXO2_DEVICES})")
message(STATUS "Enabled MachXO2 devices: ${MACHXO2_DEVICES}")

if(DEFINED MACHXO2_CHIPDB)
    add_custom_target(chipdb-machxo2-bbas ALL)
else()
    find_package(PythonInterp 3.5 REQUIRED)

    # shared among all families
    set(SERIALIZE_CHIPDBS TRUE CACHE BOOL
        "Serialize device data preprocessing to minimize memory use")

    set(TRELLIS_PROGRAM_PREFIX "" CACHE STRING
        "Trellis name prefix")
    if(TRELLIS_PROGRAM_PREFIX)
        message(STATUS "Trellis program prefix: ${TRELLIS_PROGRAM_PREFIX}")
    endif()

    set(TRELLIS_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE STRING
        "Trellis install prefix")
    message(STATUS "Trellis install prefix: ${TRELLIS_INSTALL_PREFIX}")

    if(NOT DEFINED TRELLIS_LIBDIR)
        if(WIN32)
            set(pytrellis_lib pytrellis.pyd)
        else()
            set(pytrellis_lib pytrellis${CMAKE_SHARED_LIBRARY_SUFFIX})
        endif()
        find_path(TRELLIS_LIBDIR ${pytrellis_lib}
            HINTS ${TRELLIS_INSTALL_PREFIX}/lib/${TRELLIS_PROGRAM_PREFIX}trellis
            PATHS ${CMAKE_SYSTEM_LIBRARY_PATH} ${CMAKE_LIBRARY_PATH}
            PATH_SUFFIXES ${TRELLIS_PROGRAM_PREFIX}trellis
            DOC "Location of the pytrellis library")
        if(NOT TRELLIS_LIBDIR)
            message(FATAL_ERROR "Failed to locate the pytrellis library")
        endif()
    endif()
    message(STATUS "Trellis library directory: ${TRELLIS_LIBDIR}")

    if(NOT DEFINED TRELLIS_DATADIR)
        set(TRELLIS_DATADIR ${TRELLIS_INSTALL_PREFIX}/share/${TRELLIS_PROGRAM_PREFIX}trellis)
    endif()
    message(STATUS "Trellis data directory: ${TRELLIS_DATADIR}")

    set(all_device_bbas)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/chipdb)
    foreach(device ${MACHXO2_DEVICES})
        if(NOT device IN_LIST ALL_MACHXO2_DEVICES)
            message(FATAL_ERROR "Device ${device} is not a supported MachXO2 device")
        endif()

        set(device_bba chipdb/chipdb-${device}.bba)
        add_custom_command(
            OUTPUT ${device_bba}
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/facade_import.py
                -L ${TRELLIS_LIBDIR}
                -L ${TRELLIS_DATADIR}/util/common
                -L ${TRELLIS_DATADIR}/timing/util
                -p ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
                ${device}
                > ${device_bba}.new
            # atomically update
            COMMAND ${CMAKE_COMMAND} -E rename ${device_bba}.new ${device_bba}
            DEPENDS
                ${CMAKE_CURRENT_SOURCE_DIR}/facade_import.py
                ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
                ${PREVIOUS_CHIPDB_TARGET}
            VERBATIM)
        list(APPEND all_device_bbas ${device_bba})
        if(SERIALIZE_CHIPDBS)
            set(PREVIOUS_CHIPDB_TARGET ${CMAKE_CURRENT_BINARY_DIR}/${device_bba})
        endif()
    endforeach()

    add_custom_target(chipdb-machxo2-bbas ALL DEPENDS ${all_device_bbas})

    get_directory_property(has_parent PARENT_DIRECTORY)
    if(has_parent)
        set(MACHXO2_CHIPDB ${CMAKE_CURRENT_BINARY_DIR}/chipdb PARENT_SCOPE)
        # serialize chipdb build across multiple architectures
        set(PREVIOUS_CHIPDB_TARGET chipdb-machxo2-bbas PARENT_SCOPE)
    else()
        message(STATUS "Build nextpnr with -DMACHXO2_CHIPDB=${CMAKE_CURRENT_BINARY_DIR}")
    endif()
endif()

=== 3rdparty/python-console/CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )
project( PythonInterpreter )

set(CMAKE_CXX_STANDARD 11)
find_package(Qt5 COMPONENTS Core Widgets REQUIRED)

find_package( PythonLibs REQUIRED )
include_directories( ${PYTHON_INCLUDE_DIRS} )

add_executable( test_python_interpreter test_python_interpreter.cpp Interpreter.cpp )
target_link_libraries( test_python_interpreter ${PYTHON_LIBRARIES} )

qt5_wrap_cpp( Console_MOC Console.h )
add_executable( test_console test_console.cpp
    Console.cpp ${Console_MOC}
    ColumnFormatter.cpp
    Interpreter.cpp
    ParseHelper.cpp
    ParseHelper.BlockParseState.cpp
    ParseHelper.BracketParseState.cpp
    ParseHelper.ContinuationParseState.cpp
    ParseMessage.cpp
)
target_compile_definitions( test_console PRIVATE QT_NO_KEYWORDS)
target_link_libraries( test_console Qt5::Widgets ${PYTHON_LIBRARIES} )

add_executable( test_parse_helper test_parse_helper.cpp 
    ParseHelper.cpp
    ParseHelper.BlockParseState.cpp
    ParseHelper.BracketParseState.cpp
    ParseHelper.ContinuationParseState.cpp
    ParseListener.cpp
    ParseMessage.cpp
)

add_executable( test_cli test_cli.cpp 
    ParseHelper.cpp
    ParseHelper.BlockParseState.cpp
    ParseHelper.BracketParseState.cpp
    ParseHelper.ContinuationParseState.cpp
    ParseListener.cpp
    ParseMessage.cpp
    Interpreter.cpp
)
target_link_libraries( test_cli
    ${PYTHON_LIBRARIES}
)

=== 3rdparty/QtPropertyBrowser/src/CMakeLists.txt ===
# Tell CMake to run moc when necessary:
set(CMAKE_AUTOMOC ON)

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(_SRCS
  qtbuttonpropertybrowser.cpp
  qteditorfactory.cpp
  qtgroupboxpropertybrowser.cpp
  qtpropertybrowser.cpp
  qtpropertybrowserutils.cpp
  qtpropertymanager.cpp
  qttreepropertybrowser.cpp
  qtvariantproperty.cpp
  )

set(_UI_FORMS
  )

set(_RESOURCES
  qtpropertybrowser.qrc
  )
  
QT5_WRAP_UI(_UI_SRCS ${_UI_FORMS})
QT5_ADD_RESOURCES(_QRC_SRCS ${_RESOURCES})

set(TARGET_NAME ${PROJECT_NAME})

add_library(${TARGET_NAME} STATIC
  ${_SRCS}
  ${_UI_SRCS}
  ${_QRC_SRCS}
  )

if (MSVC)
  target_compile_options(${TARGET_NAME} PRIVATE /wd4457 /wd4718)
endif()

target_link_libraries(${TARGET_NAME} Qt5::Widgets)

=== 3rdparty/pybind11/tests/requirements.txt ===
--extra-index-url https://antocuni.github.io/pypy-wheels/manylinux2010/
numpy==1.16.6; python_version<"3.6" and sys_platform!="win32"
numpy==1.18.0; platform_python_implementation=="PyPy" and sys_platform=="darwin" and python_version>="3.6"
numpy==1.19.3; (platform_python_implementation!="PyPy" or sys_platform=="linux") and python_version>="3.6" and python_version<"3.10"
pytest==4.6.9; python_version<"3.5"
pytest==5.4.3; python_version>="3.5"
scipy==1.2.3; (platform_python_implementation!="PyPy" or sys_platform=="linux") and python_version<"3.6"
scipy==1.5.2; (platform_python_implementation!="PyPy" or sys_platform=="linux") and python_version>="3.6" and python_version<"3.9"

=== 3rdparty/sanitizers-cmake/tests/CMakeLists.txt ===
# This file is part of CMake-sanitizers.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#
# Copyright (c)
#   2013-2015 Matt Arsenault
#   2015      RWTH Aachen University, Federal Republic of Germany
#

# Function to add testcases.
function(add_testcase TESTNAME SOURCEFILES)
	# remove ${TESTNAME} from ${ARGV} to use ${ARGV} as ${SOURCEFILES}
	list(REMOVE_AT ARGV 0)

	# add a new executable
	add_executable(${TESTNAME} ${ARGV})
	add_sanitizers(${TESTNAME})

	# add a testcase for executable
	add_test(${TESTNAME} ${TESTNAME})
endfunction(add_testcase)



#
# search for sanitizers
#
find_package(Sanitizers)



#
# add testcases
#
add_testcase("asan_test_cpp" asan_test.cpp)

=== 3rdparty/QtPropertyBrowser/examples/object_controller/CMakeLists.txt ===
# Tell CMake to run moc when necessary:
set(CMAKE_AUTOMOC ON)

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

SET(example_name object_controller)

SET(KIT_SRCS
  main.cpp
  objectcontroller.cpp
  )
  
ADD_EXECUTABLE(${example_name} ${KIT_SRCS})
TARGET_LINK_LIBRARIES(${example_name} ${PROJECT_NAME})

=== 3rdparty/pybind11/tests/test_cmake_build/CMakeLists.txt ===
# Built-in in CMake 3.5+
include(CMakeParseArguments)

add_custom_target(test_cmake_build)

function(pybind11_add_build_test name)
  cmake_parse_arguments(ARG "INSTALL" "" "" ${ARGN})

  set(build_options "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")

  if(PYBIND11_FINDPYTHON)
    list(APPEND build_options "-DPYBIND11_FINDPYTHON=${PYBIND11_FINDPYTHON}")

    if(DEFINED Python_ROOT_DIR)
      list(APPEND build_options "-DPython_ROOT_DIR=${Python_ROOT_DIR}")
    endif()

    list(APPEND build_options "-DPython_EXECUTABLE=${Python_EXECUTABLE}")
  else()
    list(APPEND build_options "-DPYTHON_EXECUTABLE=${PYTHON_EXECUTABLE}")
  endif()

  if(DEFINED CMAKE_CXX_STANDARD)
    list(APPEND build_options "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}")
  endif()

  if(NOT ARG_INSTALL)
    list(APPEND build_options "-DPYBIND11_PROJECT_DIR=${pybind11_SOURCE_DIR}")
  else()
    list(APPEND build_options "-DCMAKE_PREFIX_PATH=${pybind11_BINARY_DIR}/mock_install")
  endif()

  add_custom_target(
    test_build_${name}
    ${CMAKE_CTEST_COMMAND}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/${name}"
    "${CMAKE_CURRENT_BINARY_DIR}/${name}"
    --build-config
    Release
    --build-noclean
    --build-generator
    ${CMAKE_GENERATOR}
    $<$<BOOL:${CMAKE_GENERATOR_PLATFORM}>:--build-generator-platform>
    ${CMAKE_GENERATOR_PLATFORM}
    --build-makeprogram
    ${CMAKE_MAKE_PROGRAM}
    --build-target
    check_${name}
    --build-options
    ${build_options})
  if(ARG_INSTALL)
    add_dependencies(test_build_${name} mock_install)
  endif()
  add_dependencies(test_cmake_build test_build_${name})
endfunction()

pybind11_add_build_test(subdirectory_function)
pybind11_add_build_test(subdirectory_target)
if("${PYTHON_MODULE_EXTENSION}" MATCHES "pypy" OR "${Python_INTERPRETER_ID}" STREQUAL "PyPy")
  message(STATUS "Skipping embed test on PyPy")
else()
  pybind11_add_build_test(subdirectory_embed)
endif()

if(PYBIND11_INSTALL)
  add_custom_target(
    mock_install ${CMAKE_COMMAND} "-DCMAKE_INSTALL_PREFIX=${pybind11_BINARY_DIR}/mock_install" -P
                 "${pybind11_BINARY_DIR}/cmake_install.cmake")

  pybind11_add_build_test(installed_function INSTALL)
  pybind11_add_build_test(installed_target INSTALL)
  if(NOT ("${PYTHON_MODULE_EXTENSION}" MATCHES "pypy" OR "${Python_INTERPRETER_ID}" STREQUAL "PyPy"
         ))
    pybind11_add_build_test(installed_embed INSTALL)
  endif()
endif()

add_dependencies(check test_cmake_build)

=== 3rdparty/pybind11/tests/test_embed/CMakeLists.txt ===
if("${PYTHON_MODULE_EXTENSION}" MATCHES "pypy" OR "${Python_INTERPRETER_ID}" STREQUAL "PyPy")
  add_custom_target(cpptest) # Dummy target on PyPy. Embedding is not supported.
  set(_suppress_unused_variable_warning "${DOWNLOAD_CATCH}")
  return()
endif()

find_package(Catch 2.13.2)

if(CATCH_FOUND)
  message(STATUS "Building interpreter tests using Catch v${CATCH_VERSION}")
else()
  message(STATUS "Catch not detected. Interpreter tests will be skipped. Install Catch headers"
                 " manually or use `cmake -DDOWNLOAD_CATCH=ON` to fetch them automatically.")
  return()
endif()

find_package(Threads REQUIRED)

add_executable(test_embed catch.cpp test_interpreter.cpp)
pybind11_enable_warnings(test_embed)

target_link_libraries(test_embed PRIVATE pybind11::embed Catch2::Catch2 Threads::Threads)

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  file(COPY test_interpreter.py DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
endif()

add_custom_target(
  cpptest
  COMMAND "$<TARGET_FILE:test_embed>"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

pybind11_add_module(external_module THIN_LTO external_module.cpp)
set_target_properties(external_module PROPERTIES LIBRARY_OUTPUT_DIRECTORY
                                                 "${CMAKE_CURRENT_BINARY_DIR}")
foreach(config ${CMAKE_CONFIGURATION_TYPES})
  string(TOUPPER ${config} config)
  set_target_properties(external_module PROPERTIES LIBRARY_OUTPUT_DIRECTORY_${config}
                                                   "${CMAKE_CURRENT_BINARY_DIR}")
endforeach()
add_dependencies(cpptest external_module)

add_dependencies(check cpptest)

=== fpga_interchange/examples/tests/ram_nexus/CMakeLists.txt ===
add_interchange_group_test(
    name ram_nexus
    family ${family}
    board_list lifcl40evn
    tcl run_nexus.tcl
    sources ram_nexus.v
    techmap ../../remap_nexus.v
    skip_dcp
)

=== debian/changelog ===
nextpnr (0.1-1) unstable; urgency=medium

  * Fix Vcs-Git typo
  * Switch upstream to git tags
  * New upstream version 0.1

 -- Daniel Gröber <dxld@darkboxed.org>  Tue, 11 Jan 2022 18:43:33 +0100

=== debian/control ===
Source: nextpnr
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
           Nathaniel Graff <nathaniel.graff@sifive.com>
Section: electronics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               qtbase5-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-iostreams-dev,
               libqt5opengl5-dev,
               libeigen3-dev,
               python3-dev,
               fpga-icestorm-chipdb (>= 0~20180809git7e73288-2),
               help2man
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/electronics-team/nextpnr
Vcs-Git: https://salsa.debian.org/electronics-team/nextpnr.git
Homepage: https://github.com/YosysHQ/nextpnr
Rules-Requires-Root: no

Package: nextpnr-ice40
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40-qt
Replaces: nextpnr-ice40-qt
Description: FPGA place and route tool for Lattice iCE40
 nextpnr aims to be a vendor neutral, timing driven, FOSS FPGA place and route
 tool.
 .
 nextpnr-ice40 is to be used for Lattice iCE40 FPGAs and uses fpga-icestorm to
 achieve that.
 .
 This package can perform place-and-route for Lattice iCE40 devices
 and contains only the command-line functionality. For the QT GUI,
 see nextpnr-ice40-qt.

Package: nextpnr-ice40-qt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40
Replaces: nextpnr-ice40
Description: FPGA place and route tool for Lattice iCE40 - with GUI
 nextpnr aims to be a vendor neutral, timing driven, FOSS FPGA place and route
 tool.
 .
 nextpnr-ice40 is to be used for Lattice iCE40 FPGAs and uses fpga-icestorm to
 achieve that.
 .
 This package can perform place-and-route for Lattice iCE40 devices
 and includes the QT GUI.

Package: nextpnr-generic
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Place and route tool for Generic FPGAs
 nextpnr aims to be a vendor neutral, timing driven, FOSS FPGA place and route
 tool.
 .
 nextpnr-generic allows running placement and routing for arbitrary custom
 architectures. It is more experimental than nextpnr-ice40.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

BUILDDIR=build

%:
	dh $@ -B$(BUILDDIR)

CMAKE_COMMON_FLAGS = \
    -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" \
    -DCURRENT_GIT_VERSION="$(DEB_VERSION)" \
    -DBUILD_PYTHON=ON \
    -DBUILD_TESTS=ON

CMAKE_GENERIC_FLAGS = \
    $(CMAKE_COMMON_FLAGS) \
    -DARCH=generic \
    -DCMAKE_INSTALL_PREFIX=/usr

CMAKE_ICE40_FLAGS = \
    $(CMAKE_COMMON_FLAGS) \
    -DARCH=ice40 \
    -DICEBOX_DATADIR=/usr/share/fpga-icestorm/chipdb \
    -DICEBOX_ROOT=/usr/share/fpga-icestorm/chipdb \

CMAKE_ICE40_NOQT_FLAGS = \
    $(CMAKE_ICE40_FLAGS) \
    -DBUILD_GUI=OFF \
    -DCMAKE_INSTALL_PREFIX=/noqt/usr

CMAKE_ICE40_QT_FLAGS = \
    $(CMAKE_ICE40_FLAGS) \
    -DBUILD_GUI=ON \
    -DCMAKE_INSTALL_PREFIX=/qt/usr

HELP2MAN_FLAGS = \
    --name="Next Generation Place and Route" \
    --version-string="$(DEB_VERSION)" \
    --section=1 \
    --manual="General Commands" \
    --no-info \
    --no-discard-stderr

override_dh_auto_clean:
	rm -rf debian/$(BUILDDIR)
	dh_auto_clean

override_dh_auto_configure:
	cmake $(CMAKE_GENERIC_FLAGS) -S . -B debian/$(BUILDDIR)/generic
	cmake $(CMAKE_ICE40_NOQT_FLAGS) -S . -B debian/$(BUILDDIR)/ice40
	cmake $(CMAKE_ICE40_QT_FLAGS) -S . -B debian/$(BUILDDIR)/ice40-qt

override_dh_auto_build: build-generic build-ice40 build-ice40-qt

build-generic:
	make -C debian/$(BUILDDIR)/generic

build-ice40:
	make -C debian/$(BUILDDIR)/ice40

build-ice40-qt:
	make -C debian/$(BUILDDIR)/ice40-qt

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make -C debian/$(BUILDDIR)/generic test
	make -C debian/$(BUILDDIR)/ice40 test
	make -C debian/$(BUILDDIR)/ice40-qt test
endif

override_dh_auto_install:
	DESTDIR=${CURDIR}/debian/tmp make -C debian/$(BUILDDIR)/generic install
	DESTDIR=${CURDIR}/debian/tmp make -C debian/$(BUILDDIR)/ice40 install
	DESTDIR=${CURDIR}/debian/tmp make -C debian/$(BUILDDIR)/ice40-qt install

override_dh_installman:
	help2man $(HELP2MAN_FLAGS) debian/tmp/usr/bin/nextpnr-generic > debian/tmp/nextpnr-generic.1
	help2man $(HELP2MAN_FLAGS) debian/tmp/qt/usr/bin/nextpnr-ice40 > debian/tmp/nextpnr-ice40.1
	dh_installman

override_dh_installexamples:
	dh_installexamples --exclude=.gitignore


.PHONY: build-generic build-ice40 build-ice40-qt

=== debian/tests/control ===
Test-Command: nextpnr-generic --help
Depends: nextpnr-generic
Restrictions: allow-stderr

Test-Command: nextpnr-ice40 --help
Depends: nextpnr-ice40
Restrictions: allow-stderr

Test-Command: nextpnr-ice40 --help
Depends: nextpnr-ice40-qt
Restrictions: allow-stderr

## nextpnr 0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -257,7 +257,7 @@
     list(APPEND EXTRA_LIB_DEPS profiler)
 endif()
 if(TBB_FOUND)
-    list(APPEND EXTRA_LIB_DEPS tbb)
+    list(APPEND EXTRA_LIB_DEPS TBB::tbb)
 endif()
 
 foreach (family ${ARCH})

=== debian/changelog ===
nextpnr (0.3-2) unstable; urgency=medium

  * Team upload.
  * Added ref to paper
  * Extended package description [Steffen & Daniel].
  * Standards-Version: 4.6.1

 -- Steffen Moeller <moeller@debian.org>  Sun, 03 Jul 2022 14:09:34 +0200

nextpnr (0.3-1) unstable; urgency=medium

  * Team upload.

  [ Daniel Gröber ]
  * New upstream version 0.2

  [ Pino Toscano ]
  * Directly install in the destination directories
  * Properly use the dh_auto_* helpers
  * Set BUILDDIR to debian/build

  [ Daniel Gröber ]
  * Mark tests as superficial

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 27 Mar 2022 19:09:39 +0200

=== debian/control ===
Source: nextpnr
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
           Nathaniel Graff <nathaniel.graff@sifive.com>,
           Daniel Gröber <dxld@darkboxed.org>
Section: electronics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               qtbase5-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-iostreams-dev,
               libqt5opengl5-dev,
               libeigen3-dev,
               python3-dev,
               fpga-icestorm-chipdb (>= 0~20180809git7e73288-2),
               help2man
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/electronics-team/nextpnr
Vcs-Git: https://salsa.debian.org/electronics-team/nextpnr.git
Homepage: https://github.com/YosysHQ/nextpnr
Rules-Requires-Root: no

Package: nextpnr-ice40
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40-qt
Replaces: nextpnr-ice40-qt
Description: FPGA place and route tool for Lattice iCE40
 FPGA are computer chips that have parts of their logics dependent on
 parameters that can be set after production, i.e., that can be programmed.
 To map a problem to an FPGA, a program must first be broken down to a
 series of logic elements and their connections, which is performed by
 a compiler like yosys. Downstream from there nextpnr takes over and decides
 what exact logic cell should be used that is on the chip.
 .
 nextpnr is a FPGA place and route tool, taking an FPGA model specific
 topological description of the hardware to be realised and produces a
 gate-level description with logic and it's connections mapped onto onto
 specific hardwired functional units using a propagation timing-based
 algorithm. Analysing the fully implemented design for proper operation at
 speed is also supported using timing-analysis.
 .
 nextpnr-ice40 supports the Lattice iCE40 series of FPGAs and uses the
 hardware description chipdb from the fpga-icestorm package.
 .
 This package supports only the command-line interface, there is also a GUI
 version in the nextpnr-ice40-qt package.

Package: nextpnr-ice40-qt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40
Replaces: nextpnr-ice40
Description: FPGA place and route tool for Lattice iCE40 - with GUI
 FPGA are computer chips that have parts of their logics dependent on
 parameters that can be set after production, i.e., that can be programmed.
 To map a problem to an FPGA, a program must first be broken down to a
 series of logic elements and their connections, which is performed by
 a compiler like yosys. Downstream from there nextpnr takes over and decides
 what exact logic cell should be used that is on the chip.
 .
 nextpnr is a FPGA place and route tool, taking an FPGA model specific
 topological description of the hardware to be realised and produces a
 gate-level description with logic and it's connections mapped onto onto
 specific hardwired functional units using a propagation timing-based
 algorithm. Analysing the fully implemented design for proper operation at
 speed is also supported using timing-analysis.
 .
 nextpnr-ice40 supports the Lattice iCE40 series of FPGAs and uses the
 hardware description chipdb from the fpga-icestorm package.
 .
 This package supports both the GUI and command-line interfaces. A slimmer
 command-line only version is available in the nextpnr-ice40 package.

Package: nextpnr-generic
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Place and route tool for Generic FPGAs
 FPGA are computer chips that have parts of their logics dependent on
 parameters that can be set after production, i.e., that can be programmed.
 To map a problem to an FPGA, a program must first be broken down to a
 series of logic elements and their connections, which is performed by
 a compiler like yosys. Downstream from there nextpnr takes over and decides
 what exact logic cell should be used that is on the chip.
 .
 nextpnr is a FPGA place and route tool, taking an FPGA model specific
 topological description of the hardware to be realised and produces a
 gate-level description with logic and it's connections mapped onto onto
 specific hardwired functional units using a propagation timing-based
 algorithm. Analysing the fully implemented design for proper operation at
 speed is also supported using timing-analysis.
 .
 nextpnr-generic supports nextpnr's synthetic "generic" FPGA.
